## libvcflib 1.0.0~rc1+dfsg1

=== Makefile ===
#OBJ_DIR = ./
HEADERS = src/Variant.h \
		  src/split.h \
		  src/pdflib.hpp \
		  src/var.hpp \
                  src/cdflib.hpp \
		  src/rnglib.hpp \
		  src/join.h
SOURCES = src/Variant.cpp \
		  src/rnglib.cpp \
		  src/var.cpp \
		  src/pdflib.cpp \
		  src/cdflib.cpp \
		  src/split.cpp
OBJECTS= $(SOURCES:.cpp=.o)

VCF_LIB_LOCAL:=$(shell pwd)
BIN_DIR:=bin
LIB_DIR:=lib
SRC_DIR=src
INC_DIR:=include
OBJ_DIR:=obj

# TODO
#vcfstats.cpp

BIN_SOURCES = src/vcfecho.cpp \
			  src/dumpContigsFromHeader.cpp \
			  src/bFst.cpp \
			  src/hapLrt.cpp \
			  src/popStats.cpp \
			  src/wcFst.cpp \
			  src/iHS.cpp \
			  src/segmentFst.cpp \
			  src/segmentIhs.cpp \
			  src/genotypeSummary.cpp \
			  src/sequenceDiversity.cpp \
			  src/pFst.cpp \
			  src/smoother.cpp \
			  src/LD.cpp \
			  src/plotHaps.cpp \
			  src/abba-baba.cpp \
			  src/permuteGPAT++.cpp \
			  src/permuteSmooth.cpp \
			  src/normalize-iHS.cpp \
			  src/meltEHH.cpp \
			  src/vcfaltcount.cpp \
			  src/vcfhetcount.cpp \
			  src/vcfhethomratio.cpp \
			  src/vcffilter.cpp \
			  src/vcf2tsv.cpp \
			  src/vcfgenotypes.cpp \
			  src/vcfannotategenotypes.cpp \
			  src/vcfcommonsamples.cpp \
			  src/vcfremovesamples.cpp \
			  src/vcfkeepsamples.cpp \
			  src/vcfsamplenames.cpp \
			  src/vcfgenotypecompare.cpp \
			  src/vcffixup.cpp \
			  src/vcfclassify.cpp \
			  src/vcfsamplediff.cpp \
			  src/vcfremoveaberrantgenotypes.cpp \
			  src/vcfrandom.cpp \
			  src/vcfparsealts.cpp \
			  src/vcfstats.cpp \
			  src/vcfflatten.cpp \
			  src/vcfprimers.cpp \
			  src/vcfnumalt.cpp \
			  src/vcfcleancomplex.cpp \
			  src/vcfintersect.cpp \
			  src/vcfannotate.cpp \
			  src/vcfallelicprimitives.cpp \
			  src/vcfoverlay.cpp \
			  src/vcfaddinfo.cpp \
			  src/vcfkeepinfo.cpp \
			  src/vcfkeepgeno.cpp \
			  src/vcfafpath.cpp \
			  src/vcfcountalleles.cpp \
			  src/vcflength.cpp \
			  src/vcfdistance.cpp \
			  src/vcfrandomsample.cpp \
			  src/vcfentropy.cpp \
			  src/vcfglxgt.cpp \
			  src/vcfroc.cpp \
			  src/vcfcheck.cpp \
			  src/vcfstreamsort.cpp \
			  src/vcfuniq.cpp \
			  src/vcfuniqalleles.cpp \
			  src/vcfremap.cpp \
			  src/vcf2fasta.cpp \
			  src/vcfsitesummarize.cpp \
			  src/vcfbreakmulti.cpp \
			  src/vcfcreatemulti.cpp \
			  src/vcfevenregions.cpp \
			  src/vcfcat.cpp \
			  src/vcfgenosummarize.cpp \
			  src/vcfgenosamplenames.cpp \
			  src/vcfgeno2haplo.cpp \
			  src/vcfleftalign.cpp \
			  src/vcfcombine.cpp \
			  src/vcfgeno2alleles.cpp \
			  src/vcfindex.cpp \
			  src/vcf2dag.cpp \
			  src/vcfsample2info.cpp \
			  src/vcfqual2info.cpp \
			  src/vcfinfo2qual.cpp \
			  src/vcfglbound.cpp \
			  src/vcfinfosummarize.cpp

# when we can figure out how to build on mac
# src/vcfsom.cpp

#BINS = $(BIN_SOURCES:.cpp=)
BINS = $(addprefix bin/,$(notdir $(BIN_SOURCES:.cpp=)))
SHORTBINS = $(notdir $(BIN_SOURCES:.cpp=))

TABIX = tabixpp/tabix.o
FASTAHACK = fastahack/Fasta.o
SMITHWATERMAN = smithwaterman/SmithWatermanGotoh.o
REPEATS = smithwaterman/Repeats.o
INDELALLELE = smithwaterman/IndelAllele.o
DISORDER = smithwaterman/disorder.o
LEFTALIGN = smithwaterman/LeftAlign.o
FSOM = fsom/fsom.o
FILEVERCMP = filevercmp/filevercmp.o

INCLUDES = -Itabixpp/htslib -I$(INC_DIR) -L. -Ltabixpp/htslib
LDFLAGS = -L$(LIB_DIR) -lvcflib -lhts -lpthread -lz -lm -fopenmp


all: $(OBJECTS) $(BINS)


GIT_VERSION := $(shell git describe --abbrev=4 --dirty --always)

CXX = g++
CXXFLAGS = -O3 -D_FILE_OFFSET_BITS=64 -std=c++0x -DVERSION=\"$(GIT_VERSION)\"
#CXXFLAGS = -O2
#CXXFLAGS = -pedantic -Wall -Wshadow -Wpointer-arith -Wcast-qual

SSW = src/ssw.o src/ssw_cpp.o

ssw.o: src/ssw.h
ssw_cpp.o:src/ssw_cpp.h

openmp:
	$(MAKE) CXXFLAGS="$(CXXFLAGS) -fopenmp -D HAS_OPENMP"

profiling:
	$(MAKE) CXXFLAGS="$(CXXFLAGS) -g" all

gprof:
	$(MAKE) CXXFLAGS="$(CXXFLAGS) -pg" all

$(OBJECTS): $(SOURCES) $(HEADERS) $(TABIX) multichoose pre $(SMITHWATERMAN) $(FILEVERCMP)
	$(CXX) -c -o $@ src/$(*F).cpp $(INCLUDES) $(LDFLAGS) $(CXXFLAGS) && cp src/*.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/

multichoose: pre
	cd multichoose && $(MAKE) && cp *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/

intervaltree: pre
	cd intervaltree && $(MAKE) && cp *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/

$(TABIX): pre
	cd tabixpp && $(MAKE) && cp *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/

$(SMITHWATERMAN): pre
	cd smithwaterman && $(MAKE) && cp *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/ && cp *.o $(VCF_LIB_LOCAL)/$(OBJ_DIR)/

$(DISORDER): $(SMITHWATERMAN)

$(REPEATS): $(SMITHWATERMAN)

$(LEFTALIGN): $(SMITHWATERMAN)

$(INDELALLELE): $(SMITHWATERMAN)

$(FASTAHACK): pre
	cd fastahack && $(MAKE) && cp *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/ && cp Fasta.o $(VCF_LIB_LOCAL)/$(OBJ_DIR)/

#$(FSOM):
#	cd fsom && $(CXX) $(CXXFLAGS) -c fsom.c -lm

$(FILEVERCMP): pre
	cd filevercmp && make && cp *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/ && cp *.o $(VCF_LIB_LOCAL)/$(INC_DIR)/

$(SHORTBINS): pre
	$(MAKE) bin/$@

$(BINS): $(BIN_SOURCES) libvcflib.a $(OBJECTS) $(SMITHWATERMAN) $(FASTAHACK) $(DISORDER) $(LEFTALIGN) $(INDELALLELE) $(SSW) $(FILEVERCMP) pre intervaltree
	$(CXX) src/$(notdir $@).cpp -o $@ $(INCLUDES) $(LDFLAGS) $(CXXFLAGS)

libvcflib.a: $(OBJECTS) $(SMITHWATERMAN) $(REPEATS) $(FASTAHACK) $(DISORDER) $(LEFTALIGN) $(INDELALLELE) $(SSW) $(FILEVERCMP) $(TABIX) pre
	ar rs libvcflib.a $(OBJECTS) smithwaterman/sw.o $(FASTAHACK) $(SSW) $(FILEVERCMP) $(TABIX)
	cp libvcflib.a $(LIB_DIR)


test: $(BINS)
	@prove -Itests/lib -w tests/*.t

pre:
	if [ ! -d $(BIN_DIR) ]; then mkdir -p $(BIN_DIR); fi
	if [ ! -d $(LIB_DIR) ]; then mkdir -p $(LIB_DIR); fi
	if [ ! -d $(INC_DIR) ]; then mkdir -p $(INC_DIR); fi
	if [ ! -d $(OBJ_DIR) ]; then mkdir -p $(OBJ_DIR); fi


pull:
	git pull

update: pull all

clean:
	rm -f $(BINS) $(OBJECTS)
	rm -f ssw_cpp.o ssw.o
	rm -f libvcflib.a
	rm -rf $(BIN_DIR)
	rm -rf $(LIB_DIR)
	rm -rf $(INC_DIR)
	rm -rf $(OBJ_DIR)
	cd tabixpp && make clean
	cd smithwaterman && make clean
	cd fastahack && make clean

.PHONY: clean all test pre

=== debian/changelog ===
libvcflib (1.0.0~rc1+dfsg1-6) unstable; urgency=medium

  * Test suite of freebayes 1.1.0 needs vcfuniq and vcfstreamsort in PATH
    so add according links
  * Standards-Version: 4.1.0

 -- Andreas Tille <tille@debian.org>  Mon, 04 Sep 2017 16:05:56 +0200

libvcflib (1.0.0~rc1+dfsg1-5) unstable; urgency=medium

  * Fix watch file

 -- Andreas Tille <tille@debian.org>  Sat, 17 Jun 2017 23:45:29 +0200

libvcflib (1.0.0~rc1+dfsg1-4) experimental; urgency=medium

  * Re-add pkg-config file for easier usage in freebayes which was reverted
    to meet freeze policy

 -- Andreas Tille <tille@debian.org>  Fri, 17 Mar 2017 13:29:20 +0100

libvcflib (1.0.0~rc1+dfsg1-3) unstable; urgency=medium

  * Fix location of binary tools
    Closes: #856424
  * Remove empty debian/upstream/metadata boilerplate

 -- Andreas Tille <tille@debian.org>  Wed, 01 Mar 2017 15:43:05 +0100

libvcflib (1.0.0~rc1+dfsg1-2) experimental; urgency=medium

  * Add pkg-config file for easier usage in freebayes

 -- Andreas Tille <tille@debian.org>  Fri, 10 Feb 2017 09:09:35 +0100

libvcflib (1.0.0~rc1+dfsg1-1) unstable; urgency=medium

  * Adapt to recent PIE changes in dpkg (Thanks for the patch to Adrian Bunk
    <bunk@stusta.de>)
    Closes: #844890
  * d/watch: version=4
  * debhelper 10
  * Remove code copy of libssw
    Closes: #838513
  * Add lintian overrides for false positive

 -- Andreas Tille <tille@debian.org>  Tue, 22 Nov 2016 13:13:12 +0100

libvcflib (1.0.0~rc1+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #838020)

 -- Andreas Tille <tille@debian.org>  Fri, 16 Sep 2016 15:52:29 +0200

=== debian/control ===
Source: libvcflib
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               dh-exec,
               python-markdown,
               libtabixpp-dev,
               libdisorder-dev,
               libsmithwaterman-dev (>= 0.0+20160702-2),
               libssw-dev,
               libfastahack-dev,
               pkg-config,
               libipc-run3-perl
Standards-Version: 4.1.0
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/libvcflib.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/libvcflib.git
Homepage: https://github.com/ekg/vcflib

Package: libvcflib1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ library for parsing and manipulating VCF files
 The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
 intended to concisely describe reference-indexed variations between
 individuals. VCF provides a common interchange format for the description of
 variation in individuals and populations of samples, and has become the defacto
 standard reporting format for a wide array of genomic variant detectors.
 .    
 vcflib provides methods to manipulate and interpret sequence variation as it
 can be described by VCF. It is both:
 .
  * an API for parsing and operating on records of genomic variation as it can
    be described by the VCF format,
  * and a collection of command-line utilities for executing complex
    manipulations on VCF files.

Package: libvcflib-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libvcflib1 (= ${binary:Version}),
         libdisorder-dev,
         libtabixpp-dev,
         libsmithwaterman-dev,
         libssw-dev
Description: C++ library for parsing and manipulating VCF files (development)
 The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
 intended to concisely describe reference-indexed variations between
 individuals. VCF provides a common interchange format for the description of
 variation in individuals and populations of samples, and has become the defacto
 standard reporting format for a wide array of genomic variant detectors.
 .    
 vcflib provides methods to manipulate and interpret sequence variation as it
 can be described by VCF. It is both:
 .
  * an API for parsing and operating on records of genomic variation as it can
    be described by the VCF format,
  * and a collection of command-line utilities for executing complex
    manipulations on VCF files.
 .
 This package contains the static library and the header files.

Package: libvcflib-tools
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ library for parsing and manipulating VCF files (tools)
 The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
 intended to concisely describe reference-indexed variations between
 individuals. VCF provides a common interchange format for the description of
 variation in individuals and populations of samples, and has become the defacto
 standard reporting format for a wide array of genomic variant detectors.
 .    
 vcflib provides methods to manipulate and interpret sequence variation as it
 can be described by VCF. It is both:
 .
  * an API for parsing and operating on records of genomic variation as it can
    be described by the VCF format,
  * and a collection of command-line utilities for executing complex
    manipulations on VCF files.
 .
 This package contains several tools using the library.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_clean:
	dh_clean
	find . -name "*.o" -delete

override_dh_auto_build:
	dh_auto_build
	markdown_py -f README.html README.md

override_dh_auto_test:
	export LD_LIBRARY_PATH=$(CURDIR)/lib/:$LD_LIBRARY_PATH dh_auto_test

override_dh_install:
	dh_install
	find debian -name filevercmp.h -delete
	cp -a filevercmp/filevercmp.h debian/libvcflib-dev/usr/include/vcflib/
	mkdir -p debian/libvcflib-dev/usr/include/intervaltree
	mv debian/libvcflib-dev/usr/include/vcflib/IntervalTree.h debian/libvcflib-dev/usr/include/intervaltree
	mv debian/libvcflib-tools/usr/lib/vcflib/binaries debian/libvcflib-tools/usr/lib/vcflib/bin
	# install pkg-config file
	mkdir -p $(CURDIR)/debian/libvcflib-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	mv libvcflib.pc $(CURDIR)/debian/libvcflib-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig

override_dh_fixperms:
	dh_fixperms
	chmod -x debian/*/usr/lib/R/site-library/*/*.R

=== debian/watch ===
version=4

opts="uversionmangle=s/-rc/~rc/,repacksuffix=+dfsg,dversionmangle=s/\+dfsg[0-9]*//g,repack,compression=xz" \
  https://github.com/ekg/vcflib/releases .*/archive/v(\d[-\d.rc]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## libvcflib 1.0.0~rc2+dfsg

=== Makefile ===
--- 
+++ 
@@ -25,8 +25,10 @@
 #vcfstats.cpp
 
 BIN_SOURCES = src/vcfecho.cpp \
+			  src/vcfnormalizesvs.cpp \
 			  src/dumpContigsFromHeader.cpp \
 			  src/bFst.cpp \
+			  src/pVst.cpp \
 			  src/hapLrt.cpp \
 			  src/popStats.cpp \
 			  src/wcFst.cpp \
@@ -37,7 +39,7 @@
 			  src/sequenceDiversity.cpp \
 			  src/pFst.cpp \
 			  src/smoother.cpp \
-			  src/LD.cpp \
+			  src/vcfld.cpp \
 			  src/plotHaps.cpp \
 			  src/abba-baba.cpp \
 			  src/permuteGPAT++.cpp \
@@ -105,6 +107,8 @@
 			  src/vcfqual2info.cpp \
 			  src/vcfinfo2qual.cpp \
 			  src/vcfglbound.cpp \
+			  src/vcfunphase.cpp \
+			  src/vcfnull2ref.cpp \
 			  src/vcfinfosummarize.cpp
 
 # when we can figure out how to build on mac
@@ -125,23 +129,24 @@
 FILEVERCMP = filevercmp/filevercmp.o
 
 INCLUDES = -Itabixpp/htslib -I$(INC_DIR) -L. -Ltabixpp/htslib
-LDFLAGS = -L$(LIB_DIR) -lvcflib -lhts -lpthread -lz -lm -fopenmp
-
-
-all: $(OBJECTS) $(BINS)
-
+LDFLAGS = -L$(LIB_DIR) -lvcflib -lhts -lpthread -lz -lm -llzma -lbz2
+
+
+all: $(OBJECTS) $(BINS) scriptToBin
+
+scriptToBin: $(BINS)
+	cp scripts/* bin
 
 GIT_VERSION := $(shell git describe --abbrev=4 --dirty --always)
 
-CXX = g++
-CXXFLAGS = -O3 -D_FILE_OFFSET_BITS=64 -std=c++0x -DVERSION=\"$(GIT_VERSION)\"
+CXXFLAGS = -O3 -D_FILE_OFFSET_BITS=64 -std=c++0x
 #CXXFLAGS = -O2
 #CXXFLAGS = -pedantic -Wall -Wshadow -Wpointer-arith -Wcast-qual
 
 SSW = src/ssw.o src/ssw_cpp.o
 
-ssw.o: src/ssw.h
-ssw_cpp.o:src/ssw_cpp.h
+ssw.o: src/ssw.hpp
+ssw_cpp.o:src/ssw_cpp.hpp
 
 openmp:
 	$(MAKE) CXXFLAGS="$(CXXFLAGS) -fopenmp -D HAS_OPENMP"
@@ -152,7 +157,7 @@
 gprof:
 	$(MAKE) CXXFLAGS="$(CXXFLAGS) -pg" all
 
-$(OBJECTS): $(SOURCES) $(HEADERS) $(TABIX) multichoose pre $(SMITHWATERMAN) $(FILEVERCMP)
+$(OBJECTS): $(SOURCES) $(HEADERS) $(TABIX) multichoose pre $(SMITHWATERMAN) $(FILEVERCMP) $(FASTAHACK)
 	$(CXX) -c -o $@ src/$(*F).cpp $(INCLUDES) $(LDFLAGS) $(CXXFLAGS) && cp src/*.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/
 
 multichoose: pre
@@ -188,7 +193,7 @@
 	$(MAKE) bin/$@
 
 $(BINS): $(BIN_SOURCES) libvcflib.a $(OBJECTS) $(SMITHWATERMAN) $(FASTAHACK) $(DISORDER) $(LEFTALIGN) $(INDELALLELE) $(SSW) $(FILEVERCMP) pre intervaltree
-	$(CXX) src/$(notdir $@).cpp -o $@ $(INCLUDES) $(LDFLAGS) $(CXXFLAGS)
+	$(CXX) src/$(notdir $@).cpp -o $@ $(INCLUDES) $(LDFLAGS) $(CXXFLAGS) -DVERSION=\"$(GIT_VERSION)\"
 
 libvcflib.a: $(OBJECTS) $(SMITHWATERMAN) $(REPEATS) $(FASTAHACK) $(DISORDER) $(LEFTALIGN) $(INDELALLELE) $(SSW) $(FILEVERCMP) $(TABIX) pre
 	ar rs libvcflib.a $(OBJECTS) smithwaterman/sw.o $(FASTAHACK) $(SSW) $(FILEVERCMP) $(TABIX)

=== test/Makefile ===
######################################
# Makefile written by Zev Kronenberg #
#     zev.kronenberg@gmail.com       #
######################################

CC=gcc
CXX=g++
CFLAGS=-Wall -std=c++0x 
LINKERS=-lm -lpthread -lhts -lvcflib -lz 
INCLUDE=-I../src -I../googletest/googletest/include/ -I../tabixpp/ -I../tabixpp/htslib/ -I ../smithwaterman/ -I ../multichoose/ -I ../filevercmp/ -I ../googletest/googletest/make/
LIB=-L../ -L../tabixpp/htslib -L../tabixpp/htslib/ -L../googletest/googletest/make/
LIBGTEST=../googletest/googletest/make/gtest_main.a
LIBVCF=../libvcflib.a
all: run

../googletest/googletest/make/gtest_main.a:
	cd ../googletest/googletest/make/ && make
tests/main: ../googletest/googletest/make/gtest_main.a
	$(CXX) $(CFLAGS) $(INCLUDE) $(LIB) $(LINKERS) tests/mainTest.cpp ../tabixpp/tabix.cpp ../tabixpp/htslib/libhts.a $(LIBVCF) $(LIBGTEST) -o tests/main 
run: tests/main
	./tests/main
clean:
	rm tests/main

=== debian/changelog ===
libvcflib (1.0.0~rc2+dfsg-4) unstable; urgency=medium

  * Move manpage to vcflib-tools package
    Closes: #933649

 -- Andreas Tille <tille@debian.org>  Thu, 01 Aug 2019 14:39:28 +0200

libvcflib (1.0.0~rc2+dfsg-3) unstable; urgency=medium

  * Move vcf2tsv and vcfkeepinfo to /usr/bin since it is needed by freebayes
    test
  * debhelper-compat 12
  * Standards-Version: 4.4.0
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target
  * Remove trailing whitespace in debian/control
  * Override dh_dwz to do nothing

 -- Andreas Tille <tille@debian.org>  Wed, 31 Jul 2019 16:12:42 +0200

libvcflib (1.0.0~rc2+dfsg-2) unstable; urgency=medium

  * Add libfastahack to pkg-config input file
  * Depends: libfastahack-dev

 -- Andreas Tille <tille@debian.org>  Fri, 14 Sep 2018 13:56:52 +0200

libvcflib (1.0.0~rc2+dfsg-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * Created debian/upstream/metadata for references to
    registries.

  [ Andreas Tille ]
  * New upstream version
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1
  * Versioned Build-Depends:
       libfastahack-dev (>= 0.0+git20160702.bbc645f+dfsg-5~)
  * Fix header file name
  * Build-Depends: libbz2-dev
  * Fix installation target dir
  * Fix interpreter lines and add missing interpreter dependencies

 -- Andreas Tille <tille@debian.org>  Thu, 13 Sep 2018 22:34:23 +0200

=== debian/control ===
--- 
+++ 
@@ -3,19 +3,20 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 12),
                dh-exec,
                python-markdown,
                libtabixpp-dev,
+               libbz2-dev,
                libdisorder-dev,
                libsmithwaterman-dev (>= 0.0+20160702-2),
                libssw-dev,
-               libfastahack-dev,
+               libfastahack-dev (>= 0.0+git20160702.bbc645f+dfsg-5~),
                pkg-config,
                libipc-run3-perl
-Standards-Version: 4.1.0
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/libvcflib.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/libvcflib.git
+Standards-Version: 4.4.0
+Vcs-Browser: https://salsa.debian.org/med-team/libvcflib
+Vcs-Git: https://salsa.debian.org/med-team/libvcflib.git
 Homepage: https://github.com/ekg/vcflib
 
 Package: libvcflib1
@@ -29,7 +30,7 @@
  individuals. VCF provides a common interchange format for the description of
  variation in individuals and populations of samples, and has become the defacto
  standard reporting format for a wide array of genomic variant detectors.
- .    
+ .
  vcflib provides methods to manipulate and interpret sequence variation as it
  can be described by VCF. It is both:
  .
@@ -45,6 +46,7 @@
          ${misc:Depends},
          libvcflib1 (= ${binary:Version}),
          libdisorder-dev,
+         libfastahack-dev,
          libtabixpp-dev,
          libsmithwaterman-dev,
          libssw-dev
@@ -54,7 +56,7 @@
  individuals. VCF provides a common interchange format for the description of
  variation in individuals and populations of samples, and has become the defacto
  standard reporting format for a wide array of genomic variant detectors.
- .    
+ .
  vcflib provides methods to manipulate and interpret sequence variation as it
  can be described by VCF. It is both:
  .
@@ -68,14 +70,22 @@
 Package: libvcflib-tools
 Architecture: any
 Depends: ${shlibs:Depends},
-         ${misc:Depends}
+         ${misc:Depends},
+         python,
+         r-base-core,
+         r-cran-plyr,
+         r-cran-ggplot2,
+         r-cran-gridbase
+Breaks: libvcflib1 (<= 1.0.0~rc2+dfsg-3)
+Replaces: libvcflib1 (<= 1.0.0~rc2+dfsg-3)
+Suggests: r-cran-pracma
 Description: C++ library for parsing and manipulating VCF files (tools)
  The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
  intended to concisely describe reference-indexed variations between
  individuals. VCF provides a common interchange format for the description of
  variation in individuals and populations of samples, and has become the defacto
  standard reporting format for a wide array of genomic variant detectors.
- .    
+ .
  vcflib provides methods to manipulate and interpret sequence variation as it
  can be described by VCF. It is both:
  .

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,9 @@
 	markdown_py -f README.html README.md
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	export LD_LIBRARY_PATH=$(CURDIR)/lib/:$LD_LIBRARY_PATH dh_auto_test
+endif
 
 override_dh_install:
 	dh_install
@@ -28,7 +30,14 @@
 	# install pkg-config file
 	mkdir -p $(CURDIR)/debian/libvcflib-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
 	mv libvcflib.pc $(CURDIR)/debian/libvcflib-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
+	rm -rf debian/*/usr/lib/vcflib/bin/*.R
+	for pl in `grep -Rl '#!/usr/bin/env' debian/*/usr/*` ; do \
+	    sed -i '1s?^#!/usr/bin/env[[:space:]]\+perl?#!/usr/bin/perl?' $${pl} ; \
+	done
 
 override_dh_fixperms:
 	dh_fixperms
 	chmod -x debian/*/usr/lib/R/site-library/*/*.R
+
+override_dh_dwz:
+	echo "Do nothing here"

## libvcflib 1.0.1%2Bdfsg

=== filevercmp/Makefile ===
all: filevercmp

clean:
	rm -f filevercmp
	rm -f filevercmp.o

.PHONY: all clean

filevercmp.o: filevercmp.c main.c filevercmp.h
	gcc -c filevercmp.c

filevercmp: filevercmp.o
	gcc -o filevercmp main.c filevercmp.o

## libvcflib 1.0.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -20,6 +20,9 @@
 SRC_DIR=src
 INC_DIR:=include
 OBJ_DIR:=obj
+
+RM = rm -f
+CP = cp -f
 
 # TODO
 #vcfstats.cpp
@@ -115,7 +118,7 @@
 # src/vcfsom.cpp
 
 #BINS = $(BIN_SOURCES:.cpp=)
-BINS = $(addprefix bin/,$(notdir $(BIN_SOURCES:.cpp=)))
+BINS = $(addprefix $(BIN_DIR)/,$(notdir $(BIN_SOURCES:.cpp=)))
 SHORTBINS = $(notdir $(BIN_SOURCES:.cpp=))
 
 TABIX = tabixpp/tabix.o
@@ -128,18 +131,26 @@
 FSOM = fsom/fsom.o
 FILEVERCMP = filevercmp/filevercmp.o
 
-INCLUDES = -Itabixpp/htslib -I$(INC_DIR) -L. -Ltabixpp/htslib
-LDFLAGS = -L$(LIB_DIR) -lvcflib -lhts -lpthread -lz -lm -llzma -lbz2
+# Work out how to find htslib
+# Use the one we ship in tabixpp unless told otherwise by the environment
+HTS_LIB ?= $(VCF_LIB_LOCAL)/tabixpp/htslib/libhts.a
+HTS_INCLUDES ?= -I$(VCF_LIB_LOCAL)/tabixpp/htslib
+HTS_LDFLAGS ?= -L$(VCF_LIB_LOCAL)/tabixpp/htslib -lhts -lbz2 -lm -lz -llzma -pthread
+
+
+INCLUDES = $(HTS_INCLUDES) -I$(INC_DIR) 
+LDFLAGS = -L$(LIB_DIR) -lvcflib $(HTS_LDFLAGS) -lpthread -lz -lm -llzma -lbz2
+
 
 
 all: $(OBJECTS) $(BINS) scriptToBin
 
 scriptToBin: $(BINS)
-	cp scripts/* bin
-
-GIT_VERSION := $(shell git describe --abbrev=4 --dirty --always)
-
-CXXFLAGS = -O3 -D_FILE_OFFSET_BITS=64 -std=c++0x
+	$(CP) scripts/* $(BIN_DIR)
+
+GIT_VERSION += $(shell git describe --abbrev=4 --dirty --always)
+
+CXXFLAGS = -Ofast -D_FILE_OFFSET_BITS=64 -std=c++0x
 #CXXFLAGS = -O2
 #CXXFLAGS = -pedantic -Wall -Wshadow -Wpointer-arith -Wcast-qual
 
@@ -158,19 +169,19 @@
 	$(MAKE) CXXFLAGS="$(CXXFLAGS) -pg" all
 
 $(OBJECTS): $(SOURCES) $(HEADERS) $(TABIX) multichoose pre $(SMITHWATERMAN) $(FILEVERCMP) $(FASTAHACK)
-	$(CXX) -c -o $@ src/$(*F).cpp $(INCLUDES) $(LDFLAGS) $(CXXFLAGS) && cp src/*.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/
+	$(CXX) -c -o $@ src/$(*F).cpp $(INCLUDES) $(LDFLAGS) $(CXXFLAGS) && $(CP) src/*.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/
 
 multichoose: pre
-	cd multichoose && $(MAKE) && cp *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/
+	cd multichoose && $(MAKE) && $(CP) *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/
 
 intervaltree: pre
-	cd intervaltree && $(MAKE) && cp *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/
+	cd intervaltree && $(MAKE) && $(CP) *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/
 
 $(TABIX): pre
-	cd tabixpp && $(MAKE) && cp *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/
+	cd tabixpp && INCLUDES="$(HTS_INCLUDES)" LIBPATH="-L. $(HTS_LDFLAGS)" HTSLIB="$(HTS_LIB)" $(MAKE) && $(CP) *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/
 
 $(SMITHWATERMAN): pre
-	cd smithwaterman && $(MAKE) && cp *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/ && cp *.o $(VCF_LIB_LOCAL)/$(OBJ_DIR)/
+	cd smithwaterman && $(MAKE) && $(CP) *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/ && $(CP) *.o $(VCF_LIB_LOCAL)/$(OBJ_DIR)/
 
 $(DISORDER): $(SMITHWATERMAN)
 
@@ -181,23 +192,23 @@
 $(INDELALLELE): $(SMITHWATERMAN)
 
 $(FASTAHACK): pre
-	cd fastahack && $(MAKE) && cp *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/ && cp Fasta.o $(VCF_LIB_LOCAL)/$(OBJ_DIR)/
+	cd fastahack && $(MAKE) && $(CP) *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/ && $(CP) Fasta.o $(VCF_LIB_LOCAL)/$(OBJ_DIR)/
 
 #$(FSOM):
 #	cd fsom && $(CXX) $(CXXFLAGS) -c fsom.c -lm
 
 $(FILEVERCMP): pre
-	cd filevercmp && make && cp *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/ && cp *.o $(VCF_LIB_LOCAL)/$(INC_DIR)/
+	cd filevercmp && make && $(CP) *.h* $(VCF_LIB_LOCAL)/$(INC_DIR)/ && $(CP) *.o $(VCF_LIB_LOCAL)/$(INC_DIR)/
 
 $(SHORTBINS): pre
-	$(MAKE) bin/$@
+	$(MAKE) $(BIN_DIR)/$@
 
 $(BINS): $(BIN_SOURCES) libvcflib.a $(OBJECTS) $(SMITHWATERMAN) $(FASTAHACK) $(DISORDER) $(LEFTALIGN) $(INDELALLELE) $(SSW) $(FILEVERCMP) pre intervaltree
 	$(CXX) src/$(notdir $@).cpp -o $@ $(INCLUDES) $(LDFLAGS) $(CXXFLAGS) -DVERSION=\"$(GIT_VERSION)\"
 
 libvcflib.a: $(OBJECTS) $(SMITHWATERMAN) $(REPEATS) $(FASTAHACK) $(DISORDER) $(LEFTALIGN) $(INDELALLELE) $(SSW) $(FILEVERCMP) $(TABIX) pre
 	ar rs libvcflib.a $(OBJECTS) smithwaterman/sw.o $(FASTAHACK) $(SSW) $(FILEVERCMP) $(TABIX)
-	cp libvcflib.a $(LIB_DIR)
+	$(CP) libvcflib.a $(LIB_DIR)
 
 
 test: $(BINS)
@@ -216,15 +227,21 @@
 update: pull all
 
 clean:
-	rm -f $(BINS) $(OBJECTS)
-	rm -f ssw_cpp.o ssw.o
-	rm -f libvcflib.a
-	rm -rf $(BIN_DIR)
-	rm -rf $(LIB_DIR)
-	rm -rf $(INC_DIR)
-	rm -rf $(OBJ_DIR)
-	cd tabixpp && make clean
-	cd smithwaterman && make clean
-	cd fastahack && make clean
-
+	$(RM) $(BINS) $(OBJECTS)
+	$(RM) ssw_cpp.o ssw.o
+	$(RM) libvcflib.a
+	$(RM) -r $(BIN_DIR)
+	$(RM) -r $(LIB_DIR)
+	$(RM) -r $(INC_DIR)
+	$(RM) -r $(OBJ_DIR)
+	$(MAKE) clean -C tabixpp
+	$(MAKE) clean -C smithwaterman
+	$(MAKE) clean -C fastahack
+	$(MAKE) clean -C multichoose
+	$(MAKE) clean -C fsom
+	$(MAKE) clean -C libVCFH
+	$(MAKE) clean -C test
+	$(MAKE) clean -C filevercmp
+	$(MAKE) clean -C intervaltree
+	
 .PHONY: clean all test pre

=== test/Makefile ===
--- 
+++ 
@@ -20,4 +20,4 @@
 run: tests/main
 	./tests/main
 clean:
-	rm tests/main
+	rm -f tests/main

=== debian/changelog ===
libvcflib (1.0.1+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Improve the usage of these packages during cross-building

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 12 Feb 2020 13:00:17 +0100

libvcflib (1.0.1+dfsg-2) unstable; urgency=medium

  * Team upload.
  * -tools: add ${perl:Depends}
  * libvcflib{1,-dev}: add Multi-Arch: same
  * Standards-Version: 4.4.1

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 26 Dec 2019 15:54:27 +0100

libvcflib (1.0.1+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Updated homepage URL
  * Major rewrite of patches

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 11 Dec 2019 13:11:23 +0100

libvcflib (1.0.0+dfsg-2) unstable; urgency=medium

  * Use 2to3 to port to Python3
    Closes: #936930
  * Use markdown instead of python-markdown

 -- Andreas Tille <tille@debian.org>  Fri, 06 Sep 2019 09:05:48 +0200

libvcflib (1.0.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version; patches refreshed
  * libvcflib-tools: promote vcffilter to /usr/bin; add basic autopkgtests
  * hardening fixed
  * update libvcflib.pc to reference upstream libraries
  * fixed spelling typos
  * updated debian/include/IntervalTree.h from https://github.com/ekg/intervaltree/blob/master/IntervalTree.h

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 04 Sep 2019 13:00:09 +0900

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 12),
                dh-exec,
-               python-markdown,
+               markdown <!nodoc>,
                libtabixpp-dev,
                libbz2-dev,
                libdisorder-dev,
@@ -13,15 +13,16 @@
                libssw-dev,
                libfastahack-dev (>= 0.0+git20160702.bbc645f+dfsg-5~),
                pkg-config,
-               libipc-run3-perl
-Standards-Version: 4.4.0
+               libipc-run3-perl <!nocheck>
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/med-team/libvcflib
 Vcs-Git: https://salsa.debian.org/med-team/libvcflib.git
-Homepage: https://github.com/ekg/vcflib
+Homepage: https://github.com/vcflib/vcflib
 
 Package: libvcflib1
 Architecture: any
 Section: libs
+Multi-Arch: same
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: C++ library for parsing and manipulating VCF files
@@ -42,8 +43,8 @@
 Package: libvcflib-dev
 Architecture: any
 Section: libdevel
-Depends: ${shlibs:Depends},
-         ${misc:Depends},
+Multi-Arch: same
+Depends: ${misc:Depends},
          libvcflib1 (= ${binary:Version}),
          libdisorder-dev,
          libfastahack-dev,
@@ -71,7 +72,8 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         python,
+         ${perl:Depends},
+         python3:any,
          r-base-core,
          r-cran-plyr,
          r-cran-ggplot2,

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,12 @@
 #!/usr/bin/make -f
 
-# DH_VERBOSE := 1
+DH_VERBOSE := 1
 
+include /usr/share/dpkg/default.mk
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
+export HTS_LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
+export GIT_VERSION=$(DEB_VERSION)
 
 %:
 	dh $@
@@ -13,7 +17,9 @@
 
 override_dh_auto_build:
 	dh_auto_build
-	markdown_py -f README.html README.md
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS) $(DEB_BUILD_PROFILES)))
+	markdown README.md > README.html
+endif
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
@@ -26,7 +32,6 @@
 	cp -a filevercmp/filevercmp.h debian/libvcflib-dev/usr/include/vcflib/
 	mkdir -p debian/libvcflib-dev/usr/include/intervaltree
 	mv debian/libvcflib-dev/usr/include/vcflib/IntervalTree.h debian/libvcflib-dev/usr/include/intervaltree
-	mv debian/libvcflib-tools/usr/lib/vcflib/binaries debian/libvcflib-tools/usr/lib/vcflib/bin
 	# install pkg-config file
 	mkdir -p $(CURDIR)/debian/libvcflib-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
 	mv libvcflib.pc $(CURDIR)/debian/libvcflib-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
@@ -38,6 +43,3 @@
 override_dh_fixperms:
 	dh_fixperms
 	chmod -x debian/*/usr/lib/R/site-library/*/*.R
-
-override_dh_dwz:
-	echo "Do nothing here"

## libvcflib 1.0.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(vcflib)

include(ExternalProject)
include(FeatureSummary)

find_package(PkgConfig REQUIRED)

include(FindBZip2)
include(FindLibLZMA)
include(FindZLIB)

feature_summary(
  FATAL_ON_MISSING_REQUIRED_PACKAGES
  WHAT REQUIRED_PACKAGES_NOT_FOUND)

# ---- Options

option(BUILD_DOC "Build documentation" ON)
option(OPENMP "Enable OpenMP" OFF)
option(PROFILING "Enable profiling" OFF)
option(GPROF "Enable gprof profiling" OFF)

# ---- Dependencies

find_package(ZLIB)
set_package_properties(ZLIB PROPERTIES TYPE REQUIRED)
#find_package(LIBLZMA)
#set_package_properties(LIBLZMA PROPERTIES TYPE REQUIRED)
find_package(Threads)
set_package_properties(Threads PROPERTIES TYPE REQUIRED)

pkg_check_modules(HTSLIB htslib)
pkg_check_modules(TABIXPP tabixpp) # Optional

# ---- Build switches

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -std=c++0x -D_FILE_OFFSET_BITS=64 -Isrc -O3")

if(OPENMP)
  find_package(OpenMP REQUIRED)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif(OPENMP)

if(PROFILING)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
endif(PROFILING)

if(GPROF)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
endif(GPROF)

# ---- Include files

include_directories(include)
include_directories(fastahack)
include_directories(intervaltree)
include_directories(smithwaterman)
include_directories(multichoose)
include_directories(filevercmp)

if(HTSLIB_LOCAL)
  include_directories(
  ${HTSLIB_LOCAL}
  tabixpp/htslib
  contrib/htslib)
endif(HTSLIB_LOCAL)

file(GLOB INCLUDES
  src/*.h*
  multichoose/*.h*
  intervaltree/*.h*
  smithwaterman/*.h*
  fastahack/*.h*
  filevercmp/*.h*)

add_library(vcflib STATIC
    src/Variant.h
    src/split.h
    src/pdflib.hpp
    src/var.hpp
    src/cdflib.hpp
    src/rnglib.hpp
    src/join.h
    src/Variant.cpp
    src/rnglib.cpp
    src/var.cpp
    src/pdflib.cpp
    src/cdflib.cpp
    src/split.cpp
    src/ssw.hpp
    src/ssw_cpp.hpp
    fastahack/Fasta.cpp
    smithwaterman/SmithWatermanGotoh.cpp
    smithwaterman/Repeats.cpp
    smithwaterman/IndelAllele.cpp
    smithwaterman/disorder.cpp
    smithwaterman/LeftAlign.cpp
    fsom/fsom.c
    filevercmp/filevercmp.c
    )

set(BINS
    vcfecho
    dumpContigsFromHeader
    bFst
    pVst
    hapLrt
    popStats
    wcFst
    iHS
    segmentFst
    segmentIhs
    genotypeSummary
    sequenceDiversity
    pFst
    smoother
    vcfld
    plotHaps
    abba-baba
    permuteGPAT++
    permuteSmooth
    normalize-iHS
    meltEHH
    vcfaltcount
    vcfhetcount
    vcfhethomratio
    vcffilter
    vcf2tsv
    vcfgenotypes
    vcfannotategenotypes
    vcfcommonsamples
    vcfremovesamples
    vcfkeepsamples
    vcfsamplenames
    vcfgenotypecompare
    vcffixup
    vcfclassify
    vcfsamplediff
    vcfremoveaberrantgenotypes
    vcfrandom
    vcfparsealts
    vcfstats
    vcfflatten
    vcfprimers
    vcfnumalt
    vcfcleancomplex
    vcfintersect
    vcfannotate
    vcfallelicprimitives
    vcfoverlay
    vcfaddinfo
    vcfkeepinfo
    vcfkeepgeno
    vcfafpath
    vcfcountalleles
    vcflength
    vcfdistance
    vcfrandomsample
    vcfentropy
    vcfglxgt
    vcfroc
    vcfcheck
    vcfstreamsort
    vcfuniq
    vcfuniqalleles
    vcfremap
    vcf2fasta
    vcfsitesummarize
    vcfbreakmulti
    vcfcreatemulti
    vcfevenregions
    vcfcat
    vcfgenosummarize
    vcfgenosamplenames
    vcfgeno2haplo
    vcfleftalign
    vcfcombine
    vcfgeno2alleles
    vcfindex
    vcf2dag
    vcfsample2info
    vcfqual2info
    vcfinfo2qual
    vcfglbound
    vcfinfosummarize
    )

# ---- Get version

file (STRINGS "VERSION" BUILD_NUMBER)
add_definitions(-DVCFLIB_VERSION="${BUILD_NUMBER}")
add_definitions(-DVERSION="${BUILD_NUMBER}")

# ---- Build htslib
#
# Note by default we use the distributed htslib! These are
# the old instructions:

if (HTSLIB_LOCAL)

ExternalProject_Add(htslib-build
  SOURCE_DIR ${HTSLIB_LOCAL}
  BINARY_DIR ${HTSLIB_LOCAL}
  PREFIX ${CMAKE_CURRENT_BINARY_DIR}/htslib
  CONFIGURE_COMMAND ""
  BUILD_COMMAND $(MAKE) lib-static
  INSTALL_COMMAND ""
  )

add_library(htslib STATIC IMPORTED)

set_property(TARGET htslib PROPERTY
  IMPORTED_LOCATION ${HTSLIB_LOCAL}/libhts.a)
add_dependencies(htslib htslib-build)

# If the user wants to configure our HTSlib to build with libddeflate, we need
# to make sure to link against libdeflate as a transitive dependency. To do
# that, pass -DHTSLIB_EXTRA_LIBS="-ldeflate" when configuring the project with
# cmake.
# TODO: Stop vendoring in htslib and just use find_package
set(HTSLIB_EXTRA_LIBS "-lcurl" CACHE STRING "Library flags needed to link with htslib's dependencies, for chosen configuration")
set_property(TARGET htslib PROPERTY INTERFACE_LINK_LIBRARIES ${HTSLIB_EXTRA_LIBS})

endif(HTSLIB_LOCAL)

# ---- Build all

if (NOT BUILD_ONLY_LIB)
  foreach(BIN ${BINS})
    add_executable(${BIN} src/${BIN}.cpp)
    target_include_directories(${BIN} PUBLIC ${TABIXPP_LIBRARIES} ${HTSLIB_INCLUDE_DIRS})
    target_link_libraries(${BIN} vcflib tabixpp -DGIT_VERSION=0.9.0 ${TABIXPP_LIBRARIES} ${HTSLIB_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${ZLIB_LIBRARIES} ${LIBLZMA_LIBRARIES} ${BZIP2_LIBRARIES})
  endforeach(BIN ${BINS})
  install(TARGETS ${BINS} RUNTIME DESTINATION bin)
endif()

enable_testing()

# ---- Test

add_test(
    NAME RunTests
    COMMAND "make"
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/test
)

function(add_pytest TEST_FILE)
  add_test(
      NAME ${TEST_FILE}
      COMMAND python3 pytest/${TEST_FILE}.py
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/test
  )
endfunction()

function(add_pydoctest TEST_FILE)
  add_test(
      NAME ${TEST_FILE}
      COMMAND python3 -m doctest -o NORMALIZE_WHITESPACE -o REPORT_UDIFF pytest/${TEST_FILE}.md
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/test
  )
endfunction()

function(add_doctest TEST_FILE)
  add_test(
      NAME ${TEST_FILE}
      COMMAND python3 -m doctest -o NORMALIZE_WHITESPACE -o REPORT_UDIFF ../${TEST_FILE}.md
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/test
  )
endfunction()

function(add_pydoctest_fullname TEST_FILE)
  add_test(
      NAME ${TEST_FILE}
      COMMAND python3 -m doctest -o NORMALIZE_WHITESPACE -o REPORT_UDIFF ${TEST_FILE}
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/test
  )
endfunction()

# add_pytest(vcf2tsv-test)
add_pydoctest(vcf2tsv)
add_doctest(doc/vcfintersect)
add_doctest(doc/vcffilter)
# add_pydoctest_fullname(../README.md)

# ---- Build docs
#
# Generates man pages for the python doctests. Don't need
# to run every time so it is a separate command. For pandoc logic see
# https://www.howtogeek.com/682871/how-to-create-a-man-page-on-linux/
#
# cmake --build . --target man ; cmake --install .

find_program(PANDOC pandoc)

if (PANDOC)
    # note the option ALL which allows to build the docs together with the application
    add_custom_target( man
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        # COMMAND ${PANDOC} ./test/pytest/vcf2tsv.md -s -t man -o ./man/vcf2tsv.1
        COMMAND ruby ./test/scripts/bin2md.rb --man test/scripts/bin2md-template.erb
        COMMAND ruby ./test/scripts/bin2md.rb --man --index
        COMMAND ruby ./test/scripts/md2man
        # regenerate to allow for URLs in markdown docs
        COMMAND ruby ./test/scripts/bin2md.rb test/scripts/bin2md-template.erb
        COMMAND ruby ./test/scripts/bin2md.rb --index
    )
else (PANDOC)
  message("Pandoc needs to be installed to generate the man pages")
endif (PANDOC)

# ---- Install

install(TARGETS vcflib ARCHIVE DESTINATION lib)

install(FILES ${INCLUDES} DESTINATION include)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/man DESTINATION ${CMAKE_INSTALL_PREFIX}/man/man1)

=== intervaltree/Makefile ===

# Use ?= to allow overriding from the env or command-line, e.g.
#
#	make CXXFLAGS="-O3 -fPIC" install
#
# Package managers will override many of these variables automatically, so
# this is aimed at making it easy to create packages (Debian packages,
# FreeBSD ports, MacPorts, pkgsrc, etc.)

CXX ?=		c++
CXXFLAGS ?=	-Wall
DESTDIR ?=	stage
PREFIX ?=	/usr/local
MKDIR ?=	mkdir
INSTALL ?=	install -c
STRIP ?=	strip

BIN =	interval_tree_test

all: ${BIN}

${BIN}: interval_tree_test.cpp IntervalTree.h
	${CXX} ${CXXFLAGS} interval_tree_test.cpp -std=c++0x -o ${BIN}

install: all
	${MKDIR} -p ${DESTDIR}${PREFIX}/bin
	${MKDIR} -p ${DESTDIR}${PREFIX}/include/intervaltree
	${INSTALL} ${BIN} ${DESTDIR}${PREFIX}/bin
	${INSTALL} IntervalTree.h ${DESTDIR}${PREFIX}/include/intervaltree

install-strip: install
	${STRIP} ${DESTDIR}${PREFIX}/bin/${BIN}

.PHONY: clean

clean:
	rm -rf ${BIN} ${DESTDIR}

=== test/Makefile ===
######################################
# Makefile written by Zev Kronenberg #
#     zev.kronenberg@gmail.com       #
######################################

CC=gcc
CXX=g++
CFLAGS=-Wall -std=c++0x
INCLUDE=-I../src -I../googletest/googletest/include/ -I../fastahack -I../smithwaterman/ -I../multichoose/ -I../filevercmp/ -I../googletest/googletest/make/
LIB=-L../build -L../googletest/googletest/make/ -lm -ltabixpp -lhts -lpthread
LIBGTEST=../googletest/googletest/make/gtest_main.a
LIBVCF=../build/libvcflib.a

all: run

../googletest/googletest/make/gtest_main.a:
	cd ../googletest/googletest/make && make

tests/main: ../googletest/googletest/make/gtest_main.a
	$(CXX) $(CFLAGS) $(INCLUDE) tests/mainTest.cpp -o tests/main $(LIBVCF) $(LIBGTEST) $(LIB)

run: tests/main
	./tests/main
	rm -v ../googletest/googletest/make/gtest_main.a
	rm -v ../googletest/googletest/make/sample1_unittest

clean:
	rm -f tests/main

=== debian/changelog ===
libvcflib (1.0.2+dfsg-2) unstable; urgency=medium

  * Team upload.
  * debian/rules: unit tests: Use DEB_HOST_GNU_TYPE instead of
    DEB_HOST_MULTIARCH for finding the build directory

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 28 Jan 2021 13:03:40 +0100

libvcflib (1.0.2+dfsg-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * Team upload.
  * Added binaries expected by bcbio to /usr/bin
  * d/rules - clean: Removing generated README.html

  [ Michael R. Crusoe ]
  * debian/copyright: Update Files-Excluded
  * Standards-Version: 4.5.1 (routine-update)
  * New upstream release
  * Switch to cmake, update patches

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 28 Jan 2021 11:16:19 +0100

libvcflib (1.0.1+dfsg-4) unstable; urgency=medium

  * Team upload.
  * debian/patches/use_debian_packaged_smithwaterman.patch: adjust
    inclusion of the packaged
    /usr/include/smithwaterman/SmithWatermanGotoh.h
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update patch headers.
  * IntervalTree.h patch is no longer needed

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 31 Oct 2020 21:57:30 +0100

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
-               dh-exec,
+Build-Depends: debhelper-compat (= 13),
+               cmake,
                markdown <!nodoc>,
                libtabixpp-dev,
                libbz2-dev,
@@ -13,11 +13,12 @@
                libssw-dev,
                libfastahack-dev (>= 0.0+git20160702.bbc645f+dfsg-5~),
                pkg-config,
-               libipc-run3-perl <!nocheck>
-Standards-Version: 4.4.1
+               libgtest-dev <!nocheck>
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/libvcflib
 Vcs-Git: https://salsa.debian.org/med-team/libvcflib.git
 Homepage: https://github.com/vcflib/vcflib
+Rules-Requires-Root: no
 
 Package: libvcflib1
 Architecture: any
@@ -72,7 +73,6 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         ${perl:Depends},
          python3:any,
          r-base-core,
          r-cran-plyr,

=== debian/rules ===
--- 
+++ 
@@ -9,11 +9,18 @@
 export GIT_VERSION=$(DEB_VERSION)
 
 %:
-	dh $@
+	dh $@ --buildsystem cmake
 
 override_dh_clean:
 	dh_clean
 	find . -name "*.o" -delete
+	rm -f README.html
+
+override_dh_auto_clean:
+	dh_auto_clean || true
+
+override_dh_auto_configure:
+	dh_auto_configure -- -DOPENMP=ON
 
 override_dh_auto_build:
 	dh_auto_build
@@ -23,7 +30,7 @@
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	export LD_LIBRARY_PATH=$(CURDIR)/lib/:$LD_LIBRARY_PATH dh_auto_test
+	export LD_LIBRARY_PATH=$(CURDIR)/obj-${DEB_HOST_GNU_TYPE}/:$$LD_LIBRARY_PATH && cd test && $(MAKE)
 endif
 
 override_dh_install:

=== debian/watch ===
version=4

opts="uversionmangle=s/-rc/~rc/,repacksuffix=+dfsg,dversionmangle=s/\+dfsg[0-9]*//g,repack,compression=xz" \
  https://github.com/vcflib/vcflib/releases .*/vcflib-(\d[-\d.rc]+)-src\.(?:tar(?:\.gz|\.bz2)?|tgz)

## libvcflib 1.0.3%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -9,12 +9,13 @@
                libtabixpp-dev,
                libbz2-dev,
                libdisorder-dev,
-               libsmithwaterman-dev (>= 0.0+20160702-2),
+               libsmithwaterman-dev,
                libssw-dev,
-               libfastahack-dev (>= 0.0+git20160702.bbc645f+dfsg-5~),
+               libfastahack-dev,
                pkg-config,
-               libgtest-dev <!nocheck>
-Standards-Version: 4.5.1
+               libgtest-dev <!nocheck>,
+               debhelper
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/libvcflib
 Vcs-Git: https://salsa.debian.org/med-team/libvcflib.git
 Homepage: https://github.com/vcflib/vcflib
@@ -22,8 +23,8 @@
 
 Package: libvcflib1
 Architecture: any
+Multi-Arch: same
 Section: libs
-Multi-Arch: same
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: C++ library for parsing and manipulating VCF files
@@ -43,8 +44,8 @@
 
 Package: libvcflib-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
-Multi-Arch: same
 Depends: ${misc:Depends},
          libvcflib1 (= ${binary:Version}),
          libdisorder-dev,
@@ -78,9 +79,9 @@
          r-cran-plyr,
          r-cran-ggplot2,
          r-cran-gridbase
+Suggests: r-cran-pracma
 Breaks: libvcflib1 (<= 1.0.0~rc2+dfsg-3)
 Replaces: libvcflib1 (<= 1.0.0~rc2+dfsg-3)
-Suggests: r-cran-pracma
 Description: C++ library for parsing and manipulating VCF files (tools)
  The Variant Call Format (VCF) is a flat-file, tab-delimited textual format
  intended to concisely describe reference-indexed variations between
